library(coda)
library(MASS)
library(lattice)



source("C:/Users/GRJ/AAA/Programming/Biology/DENIMSimulations/Utils/scenario-dir-names.R")




read.log <- function(fpath) {
  x <- read.table(fpath, header=TRUE)
  burnin <- burnin.for.MCMC
  xb <- x[burnin:nrow(x),]
  mcmclog <- as.mcmc(xb)
  mcmclog
  }



# not used
plot.traces <- function(suffix, mcmclog) {
  xyplot(mcmclog[,c("posterior", "likelihood", "prior")],
         main=paste0("Traces ", suffix))
}


# not used
print.ESSandEstimates <- function(mcmclog) {
  cat("ESS values\n")
  print(effectiveSize(mcmclog))
  print(summary(mcmclog))
  cat("\n\n\n")
}




print.ESS <- function(sdir, rep) {
		params.fpath <- paste0(beast.dir.from.scenario.dir.and.rep(sdir, rep), "/", "locus1.log")
		mcmc <- read.log(params.fpath)
		effs <- effectiveSize(mcmc)
		posteriorESS <- effs["posterior"]
		warntext <- ""
		if (posteriorESS < 200) { warntext <- "*" }
		if (posteriorESS < 100) { warntext <- "**" }
		if (posteriorESS < 50) { warntext <- "***" }
		if (posteriorESS < 25) { warntext <- "****" }
		cat("rep", rep, "posterior ESS", posteriorESS, warntext, file=fpath.for.ESS(), append=TRUE)
		cat("rep", rep, "posterior ESS", posteriorESS, warntext)
		
}



do.ESSs.for.sdirs <- function(sdirs) {
	cat("ESSs\n\n", file=fpath.for.ESS())
	for (sdir in sdirs) {
		cat(sdir, "\n", file=fpath.for.ESS(), append=TRUE)
		cat(sdir, "\n")
		for (rep in first.replicate:last.replicate) {
			print.ESS(sdir, rep)
			cat("\n", file=fpath.for.ESS(), append=TRUE)
			cat("\n")
		}
		cat("\n", file=fpath.for.ESS(), append=TRUE)
		cat("\n")
	}
}





do.ESSs <- function(nspp) {
	if (nspp == 4) {
		do.ESSs.for.sdirs(fourspp.all.scenario.dirs)
	}
	if (nspp == 10) {
		do.ESSs.for.sdirs(tenspp.all.scenario.dirs)
	}
}





