
library(ape)
library(phangorn)
library(stringr)


source("C:/Users/GRJ/AAA/Programming/Biology/DENIMSimulations/Utils/scenario-dir-names.R")
source("C:/Users/GRJ/AAA/Programming/Biology/DENIMSimulations/Utils/mcoal-tree-to-Newick.R")




output.true.stree <- function(sdir, rep) {
	ctrlfpath <- paste0(beast.dir.from.scenario.dir.and.rep(sdir, rep), "/ctrl.txt")
	truestreefpath <- paste0(beast.dir.from.scenario.dir.and.rep(sdir, rep), "/trueStree.txt")
	newick <- mcctr.nwk.mc.file.to.newick(ctrlfpath)
  phylo <- read.tree(text=newick)
  height <- max(node.depth.edgelength(phylo)) 
  sink(truestreefpath)
	cat("#NEXUS\n\nBegin trees;\ntree TREE1 = [&R] ")
	cat(newick)
	cat("\nEnd;\n")
	sink(NULL)
	height
}



do.true.strees.in.sdirs <- function(scenario.dirs) {
	mean.height <- 0
	ntrees <- 0
	for (scenario in scenario.dirs) {
		cat(scenario, "\n")
		for (rep in first.replicate:last.replicate) {
			height <- output.true.stree(scenario, rep)
			mean.height <- mean.height + height
			ntrees <- ntrees + 1
		} 
	}
	mean.height <- mean.height / ntrees
	cat("Mean species treee height is", mean.height, "\n")
}



####################################################################################


do.true.strees <- function(nspp) {
	if (nspp == 4) {
		do.true.strees.in.sdirs(fourspp.all.scenario.dirs)
	}
	
	if (nspp == 10) {
		if (just.coal.paraphyly) {
			do.true.strees.in.sdirs(tenspp.just.coal.paraphyly.dirs)		
		} else if (just.leache) {
			do.true.strees.in.sdirs(tenspp.leache.scenario.dirs)
		} else {
			do.true.strees.in.sdirs(tenspp.all.scenario.dirs)
		}
	}
}



