# This pastes together two BEAST XML fragments which sandwich a data section made by 
# Utils\mccoal-seqs-to-xml.R. 



this.directory <- "C:/Users/GRJ/AAA/Programming/Biology/DENIMSimulations/Leache-TenSpp"

source("C:/Users/GRJ/AAA/Programming/Biology/DENIMSimulations/Utils/scenario-dir-names.R")
source("C:/Users/GRJ/AAA/Programming/Biology/DENIMSimulations/Utils/mccoal-seqs-to-xml.R")



# 
xml.before.data <- readLines(paste0(this.directory, "/", "before-data-10spp.xml"))
xml.after.data           <-  readLines(paste0(this.directory, "/", "after-data-10spp.xml"))
xml.after.data.DE.allele <-  readLines(paste0(this.directory, "/", "after-data-10spp-DE-allele.xml"))
xml.after.data.DE.mig    <-  readLines(paste0(this.directory, "/", "after-data-10spp-DE-mig.xml"))
xml.after.data.FE.allele <-  readLines(paste0(this.directory, "/", "after-data-10spp-FE-allele.xml"))
xml.after.data.FE.mig    <-  readLines(paste0(this.directory, "/", "after-data-10spp-FE-mig.xml"))
xml.after.data.FG.allele <-  readLines(paste0(this.directory, "/", "after-data-10spp-FG-allele.xml"))
xml.after.data.FG.mig    <-  readLines(paste0(this.directory, "/", "after-data-10spp-FG-mig.xml"))
# 
# 



nof.mccoal.migpats <- nrow(ten.spp.mapping)



dir.from.s.rep <- function(s, rep) {
	stopifnot(is.numeric(s))
	stopifnot(rep >= first.replicate)
	stopifnot(rep <= last.replicate)
	stopifnot(s >= 1)
	if (s <= nrow(ten.spp.mapping)) {
		paste0(BEASTresults.dir, "/", scenario.rep.fname(ten.spp.mapping[s, 3], rep))
	} else {
		paste0(BEASTresults.dir, "/", scenario.rep.fname(tenspp.time.zero.dirs[s - nrow(ten.spp.mapping)], rep))
	}
}



for (sdir in tenspp.all.scenario.dirs) {
	for (rep in first.replicate:last.replicate) {
		dpath <- beast.dir.from.scenario.dir.and.rep(sdir, rep)
		
		# write start of the BEAST XML 
		sink(paste0(dpath, "/beast.xml"))
		for (i in 1:length(xml.before.data)) {
			cat(xml.before.data[i], "\n")
		}
		
		# write data for the BEAST XML 
		convert.mccoal.xml(paste0(dpath, "/seq.txt"))
		
		# write the rest of the BEAST XML, with appropriate taxon set
		if (!is.timezero.allele(sdir)  &&  !is.timezero.mig(sdir)) {
			xad <- xml.after.data
		} else {
			if (sdir == "D-E-1-allele") {
				xad <- xml.after.data.DE.allele
			} else if (sdir == "D-E-1-mig") {
				xad <- xml.after.data.DE.mig
			}  else if (sdir == "F-E-1-allele") {
				xad <- xml.after.data.FE.allele
			} else if (sdir == "F-E-1-mig") {
				xad <- xml.after.data.FE.mig
			} else if (sdir == "F-G-1-allele") {
				xad <- xml.after.data.FG.allele
			} else if (sdir == "F-G-1-mig") {
				xad <- xml.after.data.FG.mig
			} else {
				stop("Can't find mig pattern name\n")
			}
		}
		for (i in 1:length(xad)) {
			cat(xad[i], "\n")
		}
		
		sink(NULL)
	}
	cat("Done BEAST XMLs for scenario", sdir, "\n")
}









